package util;

import java.util.HashMap;
import java.util.Map;

public class Characters {

    public static final int EOF = -1;

    public static final char BACKSLASH = '\\';
    public static final char DOUBLE_QUOTE = '\"';
    public static final char HASH = '#';
    public static final char LEFT_PARENTHESIS = '(';
    public static final char LEFT_SQUARE_BRACKET = '[';
    public static final char NEWLINE = '\n';
    public static final char PERIOD = '.';
    public static final char RIGHT_PARENTHESIS = ')';
    public static final char RIGHT_SQUARE_BRACKET = ']';
    public static final char SEMICOLON = ';';
    public static final char SINGLE_QUOTE = '\'';
    public static final char TICK_MARK = '`';
    
    public static final Map<Character, Boolean> illegalIdentifierCharacters = new HashMap<>();

    static {
        illegalIdentifierCharacters.put(DOUBLE_QUOTE, true);
        illegalIdentifierCharacters.put(SINGLE_QUOTE, true);
        illegalIdentifierCharacters.put(BACKSLASH, true);
        illegalIdentifierCharacters.put(TICK_MARK, true);
        illegalIdentifierCharacters.put(LEFT_PARENTHESIS, true);
        illegalIdentifierCharacters.put(RIGHT_PARENTHESIS, true);
        illegalIdentifierCharacters.put(LEFT_SQUARE_BRACKET, true);
        illegalIdentifierCharacters.put(RIGHT_SQUARE_BRACKET, true);
        illegalIdentifierCharacters.put(HASH, true);
        illegalIdentifierCharacters.put(PERIOD, true);
        illegalIdentifierCharacters.put(SEMICOLON, true);
    }
    
    public static boolean isLegalIdentifierCharacter(char c) {
        return (! Character.isWhitespace(c)) && (! illegalIdentifierCharacters.containsKey(c));
    }

}
